include "basics/pts.ma".
include "bool.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
axiom nat : Type[0].
axiom O : nat.
axiom S : nat -> nat.
axiom match_nat_type : \forall return_ : Type[0] . return_ -> (nat -> return_) -> nat -> return_.
axiom axiom_match_nat_type_O : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). (equal) (return_type) ((match_nat_type) (return_type) case_O case_S (O) ) case_O.
definition eq_match_nat_type_O : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). (leibniz) (return_type) ((match_nat_type) (return_type) case_O case_S (O) ) case_O := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. ((((equal_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S (O) )) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
definition sym_eq_match_nat_type_O : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). (leibniz) (return_type) case_O ((match_nat_type) (return_type) case_O case_S (O) ) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. ((((sym_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S (O) )) (case_O)) ((((eq_match_nat_type_O) (return_type)) (case_O)) (case_S)).
axiom axiom_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (equal) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n).
definition eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
definition sym_eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) (case_S n) ((match_nat_type) (return_type) case_O case_S ((S)  n)) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((sym_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
axiom filter_nat_type : \forall return_ : Type[0] . (nat -> return_) -> nat -> return_.
axiom axiom_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (equal) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ).
definition eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((axiom_filter_nat_type_O) (return_type)) (return_)).
definition sym_eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) (return_ (O) ) ((filter_nat_type) (return_type) return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((sym_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((eq_filter_nat_type_O) (return_type)) (return_)).
axiom axiom_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (equal) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)).
definition eq_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ ((S)  n))) (return_ ((S)  n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
definition sym_eq_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (leibniz) (return_type) (return_ ((S)  n)) ((filter_nat_type) (return_type) return_ ((S)  n)) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. \lambda n : nat. ((((sym_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ ((S)  n))) (return_ ((S)  n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
axiom nat_ind : \forall (Q:nat -> Prop). (Q (O) ) -> (\forall (x:nat). (Q x) -> Q ((S)  x)) -> \forall (x:nat). Q x.
axiom eqb : nat -> nat -> bool.
axiom eqb_body : nat -> nat -> bool.
axiom axiom_eqb : \forall (n:nat). (equal) (nat -> bool) ((eqb)  n) ((filter_nat_type) (nat -> bool) (eqb_body)  n).
definition eq_eqb : \forall (n:nat). (leibniz) (nat -> bool) ((eqb)  n) ((filter_nat_type) (nat -> bool) (eqb_body)  n) := \lambda n : nat. ((((equal_leibniz) (nat -> bool)) ((eqb)  n)) ((filter_nat_type) (nat -> bool) (eqb_body)  n)) ((axiom_eqb) (n)).
definition sym_eq_eqb : \forall (n:nat). (leibniz) (nat -> bool) ((filter_nat_type) (nat -> bool) (eqb_body)  n) ((eqb)  n) := \lambda n : nat. ((((sym_leibniz) (nat -> bool)) ((eqb)  n)) ((filter_nat_type) (nat -> bool) (eqb_body)  n)) ((eq_eqb) (n)).
axiom axiom_eqb_body_O : (equal) (nat -> bool) ((eqb_body)  (O) ) (\lambda m : nat. (match_nat_type) (bool) (true)  (\lambda q : nat. (false) ) m).
definition eq_eqb_body_O : (leibniz) (nat -> bool) ((eqb_body)  (O) ) (\lambda m : nat. (match_nat_type) (bool) (true)  (\lambda q : nat. (false) ) m) := ((((equal_leibniz) (nat -> bool)) ((eqb_body)  (O) )) (\lambda m : nat. (match_nat_type) (bool) (true)  (\lambda q : nat. (false) ) m)) (axiom_eqb_body_O).
definition sym_eq_eqb_body_O : (leibniz) (nat -> bool) (\lambda m : nat. (match_nat_type) (bool) (true)  (\lambda q : nat. (false) ) m) ((eqb_body)  (O) ) := ((((sym_leibniz) (nat -> bool)) ((eqb_body)  (O) )) (\lambda m : nat. (match_nat_type) (bool) (true)  (\lambda q : nat. (false) ) m)) (eq_eqb_body_O).
axiom axiom_eqb_body_S : \forall (n:nat). (equal) (nat -> bool) ((eqb_body)  ((S)  n)) (\lambda m : nat. (match_nat_type) (bool) (false)  (\lambda q : nat. (eqb)  n q) m).
definition eq_eqb_body_S : \forall (n:nat). (leibniz) (nat -> bool) ((eqb_body)  ((S)  n)) (\lambda m : nat. (match_nat_type) (bool) (false)  (\lambda q : nat. (eqb)  n q) m) := \lambda n : nat. ((((equal_leibniz) (nat -> bool)) ((eqb_body)  ((S)  n))) (\lambda m : nat. (match_nat_type) (bool) (false)  (\lambda q : nat. (eqb)  n q) m)) ((axiom_eqb_body_S) (n)).
definition sym_eq_eqb_body_S : \forall (n:nat). (leibniz) (nat -> bool) (\lambda m : nat. (match_nat_type) (bool) (false)  (\lambda q : nat. (eqb)  n q) m) ((eqb_body)  ((S)  n)) := \lambda n : nat. ((((sym_leibniz) (nat -> bool)) ((eqb_body)  ((S)  n))) (\lambda m : nat. (match_nat_type) (bool) (false)  (\lambda q : nat. (eqb)  n q) m)) ((eq_eqb_body_S) (n)).
definition eqb_n_n : \forall (n:nat). (eq) (bool) ((eqb)  n n) (true)  := \lambda n : nat. ((((nat_ind) (\lambda j_x_365 : nat. (eq) (bool) ((eqb)  j_x_365 j_x_365) (true) )) ((((sym_eq_eqb) ((O) )) (\lambda y : nat -> bool. (eq) (bool) (y (O) ) (true) )) (((((sym_eq_filter_nat_type_O) (nat -> bool)) ((eqb_body) )) (\lambda y : nat -> bool. (eq) (bool) (y (O) ) (true) )) (((sym_eq_eqb_body_O) (\lambda y : nat -> bool. (eq) (bool) (y (O) ) (true) )) ((((((sym_eq_match_nat_type_O) (bool)) ((true) )) (\lambda q : nat. (false) )) (\lambda y : bool. (eq) (bool) y (true) )) (((refl) (bool)) ((true) ))))))) (\lambda x_366 : nat. (((sym_eq_eqb) ((S)  x_366)) (\lambda y : nat -> bool. ((eq) (bool) ((eqb)  x_366 x_366) (true) ) -> (eq) (bool) (y ((S)  x_366)) (true) )) ((((((sym_eq_filter_nat_type_S) (nat -> bool)) ((eqb_body) )) (x_366)) (\lambda y : nat -> bool. ((eq) (bool) ((eqb)  x_366 x_366) (true) ) -> (eq) (bool) (y ((S)  x_366)) (true) )) ((((sym_eq_eqb_body_S) (x_366)) (\lambda y : nat -> bool. ((eq) (bool) ((eqb)  x_366 x_366) (true) ) -> (eq) (bool) (y ((S)  x_366)) (true) )) (((((((sym_eq_match_nat_type_S) (bool)) ((false) )) (\lambda q : nat. (eqb)  x_366 q)) (x_366)) (\lambda y : bool. ((eq) (bool) ((eqb)  x_366 x_366) (true) ) -> (eq) (bool) y (true) )) (\lambda j_x_368 : (eq) (bool) ((eqb)  x_366 x_366) (true) . (((((((rewrite_r) (bool)) ((true) )) (\lambda j__ : bool. (eq) (bool) j__ (true) )) (((refl) (bool)) ((true) ))) ((eqb)  x_366 x_366)) (j_x_368)))))))) (n).
definition eq_to_eqb_true : \forall (n:nat). \forall (m:nat). ((eq) (nat) n m) -> (eq) (bool) ((eqb)  n m) (true)  := \lambda n : nat. \lambda m : nat. \lambda auto : (eq) (nat) n m. (((((((rewrite_l) (nat)) (n)) (\lambda j__ : nat. (eq) (bool) ((eqb)  n j__) (true) )) (((((((rewrite_r) (bool)) ((true) )) (\lambda j__ : bool. (eq) (bool) j__ (true) )) (((refl) (bool)) ((true) ))) ((eqb)  n n)) ((eqb_n_n) (n)))) (m)) (auto)).
